leetcode热题100(11) - 盛最多水的容器

Question

leetcode.cn/problems/co...

给定一个长度为 n 的整数数组 height 。有 n 条垂线,第 i 条线的两个端点是 (i, 0) 和 (i, height[i]) 。

找出其中的两条线,使得它们与 x 轴共同构成的容器可以容纳最多的水。

返回容器可以储存的最大水量。

说明:你不能倾斜容器。

示例 1:

css 复制代码
输入:[1,8,6,2,5,4,8,3,7]
输出:49 
解释:
图中垂直线代表输入数组 [1,8,6,2,5,4,8,3,7]。在此情况下,容器能够容纳水(表示为蓝色部分)的最大值为 49。

示例 2:

css 复制代码
输入:height = [1,1]
输出:1

提示:

  • n == height.length
  • 2 <= n <= 105
  • 0 <= height[i] <= 104

Solution

双指针

本题要求容纳最大的水量,实际上就是求两根线之间的最大面积。

在本题中,宽就是两条线的距离,高就是两条线中矮 的那条,因此我们可以考虑使用双指针法,左指针l指向0,右指针r指向nums.length-1 ,此时的面积为: min(numsl,numsr)*(r-l) ,我们可以将l 右移或者r 左移。

那么什么时候右移l ,什么情况下左移r 呢?不管是l 还是r在移动过程中,宽(r-l) 是减小的,而要保证宽度减少的情况下,面积还能增大,我们只能移动矮 的那条线,这样如果矮的那条线移动之后能变大,面积才有可能变大。因此每次循环我们都需判断l 和r 的大小,移动矮 的那条线,当l 和r 重合时,循环结束。

java 复制代码
static class Solution1 {

        public int maxArea(int[] height) {
            if (height.length == 0) {
                return 0;
            }
            int answer = 0;
            int l = 0;
            int r = height.length - 1;
            while (l < r) {
                int area = Math.min(height[l], height[r]) * (r - l); // 计算面积
                answer = Math.max(answer, area);

                // 矮的边移动
                if (height[l] < height[r]) {
                    l++;
                } else {
                    r--;
                }
            }
            return answer;
        }
    }

时间复杂度

O(n), n数组长度,我们需要依次访问每一个元素。

空间复杂度

O(1),需使用固定的几个变量。

相关推荐
lzhdim6 小时前
AI的分类
人工智能·算法·机器学习·分类·数据挖掘
凤凰院凶涛QAQ9 小时前
《Java版数据结构 & 集合类剖析》Map & Set & 反射:“从哈希碰撞到红黑树转换,反射帮你扒开 HashMap 的桶数组看个究竟”
java·数据结构·算法
w_zero_one10 小时前
算法--模拟
java·数据结构·算法
秋天的怀念_David11 小时前
算法一千零一夜 · 第十三夜 幻方,武侠世界里的数学迷宫
java·程序人生·算法
秋天的怀念_David12 小时前
算法一千零一夜 · 第十四夜 幻方与奇妙的二进制
java·程序人生·算法
薛定e的猫咪12 小时前
(ICLR 2020)MAML 靠的不是快速学习,而是特征复用
人工智能·深度学习·学习·算法·机器学习
薛定e的猫咪12 小时前
(ICLR 2026)DF-META:面向 FJSP 的无导数元学习实例自适应调度
人工智能·深度学习·学习·算法·机器学习
小羊没烦恼!14 小时前
异步编程:线程概述及使用
java·开发语言·mysql·算法·c#
wanderist.14 小时前
202609CSP认证P3
算法
云淡风轻~窗明几净14 小时前
角谷猜想最接近严格证明的测试 Version1.1.1
人工智能·算法·机器学习·图论